/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2007 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: target_config.c 1598 2009-06-29 09:43:33Z ertl-honda $
 */

/*
 *  åȰ¸⥸塼APSH4Aѡ
 */

#include "kernel_impl.h"
#include <sil.h>
#include "pdic/sh/sh_scif.h"
#include "apsh4a.h"

#ifdef ROM_BOOT
uint32_t __dummy = 1;
#endif

/*
 *  åȰ¸ν
 */
void
target_initialize(void)
{
    /*
     *  ץå¸ν
     */
    prc_initialize();


    /*
     *  GPIOΥ쥸ꤷSCIF0Υԥͭˤ
     */
    sil_wrh_mem((void *)GPIO_PHCP,
                (sil_reh_mem((void *)GPIO_PHCP) & GPIO_PHCP_SCIF0_ENABLE));
    
    /*
     * СʡѤΥꥢ륳ȥν
     */
    sh_scif_init(TARGET_PUTC_PORTID);    
}

/*
 *  åȰ¸νλ
 */
void
target_exit(void)
{
    /*
     *  ץå¸νλ
     */
    prc_terminate();

    /*
     *  ȯĶ¸νλ
     */
    apsh4a_exit();

    /*
     * ˤʤ
     */
    while(1);
}

/*
 *  ƥ٥ϤΤʸ
 */
void
target_fput_log(char_t c)
{
    if (c == '\n') {
        sh_scif_pol_putc('\r', TARGET_PUTC_PORTID);
    }
    sh_scif_pol_putc(c, TARGET_PUTC_PORTID);
}
