/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel  
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2007 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN  
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: ms7727cp01.h 2107 2011-06-21 13:49:25Z ertl-honda $
 */

/*
 *  MS7727CP01 CPUܡɤΤΥϡɥ񸻤
 */

#ifndef MS7727CP01_H
#define MS7727CP01_H

#include <sil.h>
#include "sh34_gcc/sh7727.h"

/*
 *  st16c2550  
 *  PORT A  H8 ³Ƥ
 */
#define ST16C_CHA 0xba000000U  /* ݡA١ɥ쥹 */
#define ST16C_CHB 0xbb000000U  /* ݡB١ɥ쥹 */

/* 
 *  ST16C2550ˤPINT7PINT6³Ƥ
 */
#define ST16C2550_INT PINT0_7_INTEVT


#ifndef TOPPERS_MACRO_ONLY

/*
 *  ȯĶ¸ν
 */
Inline void
ms7727cp01_exit(void)
{
    uint32_t sr = 0x10000000U;
    
    /*
     * Ū˥ꥻåȤȯ
     */
    /*
     * BLӥåȤΩƤ
     */
    Asm("ldc %0, sr" : : "r"(sr) );
    
    /*
     * 㳰
     */
    *((volatile int *) 0xFFFFFEC1U) = 0;
} 
#endif /* TOPPERS_MACRO_ONLY */

#endif /*  MS7727CP01_H */
